2007-04-03  Sebastien Pouliot  <sebastien@ximian.com>

	* Xlib.cs: Remove import of libgdiplus' GetFontMetrics (it doesn't 
	exists anymore).
	* XplatUIX11-new.cs: Re-implement GetFontMetrics with existing APIs.

2007-04-03  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* XplatUIX11-new.cs: Port changes from XplatUIX11.cs

2007-03-29  Everaldo Canuto  <everaldo@simios.org>

	* XplatUIX11-new.cs: Prevent system to open more than one balloon.

2007-03-29  Everaldo Canuto  <everaldo@simios.org>

	* XplatUIX11-new.cs: Implement SystrayBalloon for X11 systems. 

2007-03-20  Everaldo Canuto  <everaldo@simios.org>

	* XplatUIX11-new.cs: Remove unneeded parameter owner in SetTopmost. 

2007-03-20  Everaldo Canuto  <everaldo@simios.org>

	* XplatUIX11-new.cs, X11Hwnd.cs: Set _NET_WM_STATE_ABOVE on SetTopmost, it 
	fixes Topmost behavior in X11 environments. 

2007-03-19  Everaldo Canuto  <everaldo@simios.org>

	* XplatUIX11-new.cs, X11Hwnd.cs: SetOwner implemented using same code from
	SetTopmost but cheking for null owner to remove transient. The SetTopmost
	will be change on a decond step.

2007-03-15  Andreia Gaita  <avidigal@novell.com>

	* X11Display.cs: Fire extra MouseMove events right after
	MouseDown and MouseUp, emulating win32's <censored> behaviour
	for apps that rely on it.
	
2007-03-15  Chris Toshok  <toshok@ximian.com>

	* XplatUIX11-new.cs: implement VirtualScreen by getting
	X11Display.VirtualScreen instead of using WorkingArea.

	* X11Display.cs: implement VirtualScreen.

2007-03-15  Ivan N. Zlatev <contact@i-nz.net>

	* X11Display.cs: Replaces all uses of the custom 
	WM_MOUSE_LEAVE with the system WM_MOUSELEAVE message.

2007-03-02  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* X11Hwnd.cs: Update to use ToolWindowManager.

2007-02-08  Chris Toshok  <toshok@ximian.com>

	* X11Display.cs: port over some more changes from XplatUIX11.cs.

2007-01-31  Jackson Harper  <jackson@ximian.com>

	* X11Display.cs: Give teh keyboard to teh dnd.

2007-01-30  Chris Toshok  <toshok@ximian.com>

	* X11Display.cs: port over jackson's XplatUIX11.cs fix for DND
	ButtonRelease handling.

2007-01-30  Chris Toshok  <toshok@ximian.com>

	* X11Hwnd.cs: port over the XplatUIX11.cs patch for SetIcon.

2007-01-11  Chris Toshok  <toshok@ximian.com>

	* X11Display.cs: don't send duplicate WM_ACTIVATE messages to the
	initial form.

2007-01-06  Everaldo Canuto  <everaldo@simios.org>

	* X11Hwnd.cs, XplatUIX11-new.cs: 
	- border_static field added, it will used to define when a
	control theres 3D border but it must be static (thin).
	- In GetWindowRectangle use Theme.BorderSize to calculate area 
	instead of static value 1, by the way use BorderSize instead
	Border3DSize when border_static is true.
	- When WS_EX_STATICEDGE ExStyle is set define border_static as true.

2007-01-05  Chris Toshok  <toshok@ximian.com>

	* X11ThreadQueue.cs: #ifdef out some spew.

	* X11Display.cs: #ifdef out some spew, and comment out the calls
	to XGrabServer in QueryPointer().  it's not good to need to do
	this, but without it we seem to deadlock.

2007-01-03  Andreia Gaita  <avidigal@novell.com>
	
	XplatUIX11.cs (see main changelog)
	X11Display.cs: Check for valid window handle.

2006-12-28  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* X11Display.cs:
	* XplatUIX11-new.cs: Implemented GetOffscreenGraphics and 
	change CreateOffscreenDrawable and DestroyOffscreenDrawable to
	have the new correct signature.
	
2006-12-25  Chris Toshok  <toshok@ximian.com>

	* X11Display.cs: simplify GetMessage a lot.  remove the
	paint/configure queue code from here, it's now in X11ThreadQueue.
	reindent it by breaking out of the loop immediately if got_xevent
	== false.

	* X11ThreadQueue.cs: fix some of the the
	threadqueue.Dequeue/display.GetMessage cross-linkages..  the only
	remaining issue now (right here, anyway), is the WM_ENTERIDLE code
	remaining in the GetMessage code.  it needs to somehow be linked
	up with the OnIdle call...  maybe we need a special return value
	which we return once before calling OnIdle and waiting on the
	Monitor?

	also, fix a bug in the PaintQueue code where the Dequeue method
	was removing the Hwnd from the queue.  We only add an Hwnd once
	regardless of how many of (pending_expose, pending_nc_expose) are
	true, so we need to only remove it when both are false.  Once all
	this is working we need to determine whether or not all this paint
	queue stuff actually helps performance.

2006-12-12  Chris Toshok  <toshok@ximian.com>

	* XplatUIX11.cs: add working implementation for
	DrawReversibleFrame, DrawReversibleLine, and
	FillReversibleRectangle.

	* XplatUIX11-new.cs: add DrawReversibleFrame, DrawReversibleLine,
	and FillReversibleRectangle which call into X11Display's methods.
	
2006-12-07  Chris Toshok  <toshok@ximian.com>

	* XplatUIX11-new.cs: add the 3 double buffering calls, calling
	into the X11Display.

	* Xlib.cs: add XCreatePixmap.

	* X11Display.cs: implement the double buffering calls the same as
	XplatUIX11.cs.

2006-12-06  Chris Toshok  <toshok@ximian.com>

	* X11Display.cs: make Control.child_controls private.  switch all
	uses over to Control.Controls.

2006-12-05  Chris Toshok  <toshok@ximian.com>

	* X11Display.cs: fix some compiler warnings, and also re-include
	the autorepeat event filtering from XplatUIX11.cs.

2006-12-01  Chris Toshok  <toshok@ximian.com>

	* X11Hwnd.cs: need to mark queue as "new" to quiet mcs.

2006-11-29  Chris Toshok  <toshok@ximian.com>

	* X11Hwnd.cs: implement GetWindowTransparency, and also add
	caching for WINDOW_TYPE and _NET_WM_WINDOW_OPACITY.  We invalidate
	the cache when we get a PropertyNotify on that atom.

	* X11Display.cs: return GetSet from SupportsTransparency if we
	have a compositor running.  otherwise return None.

	* XplatUIX11-new.cs: pass SupportsTransparency off onto the
	X11Display, and pass GetWindowTransparency off onto the X11Hwnd.

2006-11-29  Chris Toshok  <toshok@ximian.com>

	* X11ThreadQueue.cs (EnqueueUnlocked): add the switch motionnotify
	compression/NeedDispatchIdle assignment found in X11Hwnd here.
	(RemovePaintUnlocked): nuke
	(AddPaintUnlocked): nuke
	(AddConfigureUnlocked): rename to AddConfigure.

	Add some debug stuff to HwndEventQueue so we can see the stack
	trace of where the hwnd was added to the queue, in case we somehow
	try to add it multiple times.

	* X11Hwnd.cs (AddExpose): there's no need for this to have locks
	around it - it should only ever be called from operations on the
	hwnd's thread (from ScrollWindow, from GetMessage, from
	Invalidate).
	(AddConfigureNotify): same goes here.
	(HandleConfigureNotify): remove configure_lock reference.
	(EnqueueEvent): nuke this.
	(PaintEventStart): remove locking.
	(ScrollWindow): remove locking.
	
	also, remove all references to
	AddPaintUnlocked/RemovePaintUnlocked/AddConfigureUnlocked.  since
	we don't need to lock around them, there's not need.
	
	* X11Display.cs (XEventThread) switch from hwnd.EnqueueEvent to
	hwnd.Queue.Enqueue.

2006-11-28  Chris Toshok  <toshok@ximian.com>

	* X11ThreadQueue.cs: factor out all the commonality from
	PaintQueue/ConfigureQueue.  Add a comment about XEventQueue.  stop
	using % from the XEventQueue.  if we're going for performance,
	it's much quicker to use a multiple of 2 size for the array and
	use & for wrapping.  Also, fix XEventQueue.Grow().  it was
	reordering the queue before.

	* X11Hwnd.cs, XplatUIX11-new.cs: remove spew, and ^M's.

2006-11-28  Rolf Bjarne Kvinge <RKvinge@novell.com>
	
	* XplatUIX11-new.cs:
	* X11Hwnd.cs:
	- Added RequestAdditionalWM_NCMessages for windows to 
	  opt in for WM_NCMOUSELEAVE and WM_NCMOUSEHOVER.

2006-11-28  Chris Toshok  <toshok@ximian.com>

	* X11Display.cs (XEventThread): move to a polling strategy again,
	since XNextEvent locks the display - without this, nothing can
	happen with any toplevel X call until there's an event.  So we
	poll on the XConnectionNumber, then consume all available events
	before polling again.
	(DispatchMessage): move this here.
	(SetCursor): same.
	(OverrideCursor): same.
	(RedirectMsgToEnabledAncestor): make this code work for any XEvent
	by removing the XEvent from the arg list.
	(GetMessage): pretty major overhaul.  we now have a 3 loops.  We
	loop over all the X events in the queue until there aren't any,
	calling AddExpose and AddConfigureNotify for Expose and Configure
	events respectively.  Those methods end up queueing up special
	"events" in the thread queue's Paint and Configure queues.  Once
	the X event loop is finished, we check to see if there are pending
	configure/paint events, and handle any that are present.
	(DoEvents): move here.

	* X11ThreadQueue.cs: make DequeueUnlocked only dequeue X events.
	if there are no x events and there *are* paint or configure
	events, return early.  add a "configure queue" which is almost
	identical to the "paint queue" except for the events it generates.
	this needs refactoring so the code can be shared.

	* XplatUIX11-new.cs: move the DefWndProc to X11Hwnd.  Move
	SetCursor, OverrideCursor, DispatchMessage and DoEvents to
	X11Display.

	* X11Hwnd.cs (Update): do all this under the queue lock..
	theorize about whether or not the SendMessage (WM_PAINT) should be
	called from under the lock.
	(DefWndProc): move this here.
	(PendingExpose,PendingNCExpose): new properties, which should
	eventually be pushed into Hwnd (and made abstract?)  Move all the
	queue manipulation here.
	(PaintEventStart): restrict the queue lock code a bit more.
	(PerformNCCalc): remove the optimization - it keeps client windows
	from resizing along with their parent.
	(SetPosition): track change Rolf made to XplatUIX11.cs on
	2006-11-22.

2006-11-21  Chris Toshok  <toshok@ximian.com>

	* X11Hwnd.cs: the IntPtr atom change broke the Array.Sort stuff I
	was doing.  Just remove it.

	* XplatUIX11-new.cs: add a message if Xlib.XInitThreads fails.

	* X11ThreadQueue.cs: another Date.Now -> Date.UtcNow fix.

	* X11RootHwnd.cs: remove the setting of Display.ActiveWindow from
	here.  move all the logic into X11Display.SetActiveWindow.

	* X11Display.cs: move the logic for setting ActiveWindow here, and
	make ModalWindows private.
	
2006-11-21  Chris Toshok  <toshok@ximian.com>

	* Xlib.cs: remove the static keyword from the class

2006-11-21  Chris Toshok  <toshok@ximian.com>

	* XplatUIX11-new.cs: implement the Idle event by adding/removing
	it from the applicable X11ThreadQueue and remove the OnIdle
	method.  Also, implement the new InvalidateNC method.

	* X11Display.cs: remove the idle dispatch code, as it can't be
	generated by the XEventThread.  It has to be generated by the
	threads running the various message pumps, as it has to be invoked
	on that same thread.  Factor out the use of Hwnd.EnabledHwnd along
	with the accompanying call to XTranslateCoordinates to a separate
	function (RedirectMsgToEnabledAncestor).  Fix some NRE's accessing
	FocusWindow, since it's not an IntPtr anymore but a X11Hwnd.

	* X11ThreadQueue.cs: move the Idle dispatch stuff here.  Also,
	correct the first arg to Idle - it's not the XplatUI, it's the
	Thread.

	* X11Hwnd.cs: numerous formatting changes, change the logic of
	some if statements to make things cleaner.  Factor out the
	USER_TIME manipulation from a few places. Change all atom
	manipulation to use IntPtr's instead of int's the way the old
	XplatUIX11 stuff worked.  This might help fix things for 64-bit
	platforms..  more work needed there.  Also, add the new
	InvalidateNC support (basically the same as the old
	InvalidateWholeWindow), and remove the InvalidateWholeWindow
	calls.

2006-11-17  Chris Toshok  <toshok@ximian.com>

	* X11Hwnd.cs: port the XplatUIX11.ScrollWindow fix from 68061.

2006-11-14  Chris Toshok  <toshok@ximian.com>

	* X11Hwnd.cs, X11RootHwnd.cs, X11Atoms.cs, X11Display.cs,
	X11Exception.cs, Xlib.cs: Initial pass at refactoring the X11
	backend.

